// Read the text at the end of EPPLUGIN.PAS how to install the demo
Library PIDemo1;

uses
 Strings,OS2PMApi,OS2Def,EPPlugIn;

Function PlugInInstall(Window : HWnd;Param1,Param2 : LongInt) : LongInt; cdecl; export;
 const
  {DLLFileName = 'e:\vp11\out\pidemo1.dll';}
  DLLFileName = 'pidemo1.dll'; //must be in libpath!
  PI1Info : TPlugInStruct = (Size:SizeOf(TPlugInStruct);
                             MenuText:'Hello';
                             MenuInfo:'Editor+ Plug-in interface demo 1';
                             DLLName:DLLFileName;
                             FunctionName:nil;
                             FunctionNr:2);
  PI2Info : TPlugInStruct = (Size:SizeOf(TPlugInStruct);
                             MenuText:'Upper case';
                             MenuInfo:'Convert the whole text to upper case';
                             DLLName:DLLFileName;
                             FunctionName:nil;
                             FunctionNr:3);
  PI3Info : TPlugInStruct = (Size:SizeOf(TPlugInStruct);
                             MenuText:'Lower case';
                             MenuInfo:'Convert the whole text to lower case';
                             DLLName:DLLFileName;
                             FunctionName:nil;
                             FunctionNr:4);
 begin
  WinSendMsg(Window,pim_Init,0,0);
  WinSendMsg(Window,pim_InstallPlugIn,LongInt(@PI1Info),0);
  WinSendMsg(Window,pim_InstallPlugIn,LongInt(@PI2Info),0);
  WinSendMsg(Window,pim_InstallPlugIn,LongInt(@PI3Info),0);
  WinSendMsg(Window,pim_End,0,0);
  PlugInInstall := 0;
end;

Function PlugInFunc1(Window : HWnd;Param1,Param2 : LongInt) : LongInt; cdecl; export;
 var
  MainWindow : HWnd;
 begin
  WinSendMsg(Window,pim_Init,0,0);
  MainWindow := WinSendMsg(Window,pim_GetMainWindow,0,0);
  WinMessageBox(HWnd_Desktop,MainWindow,'Welcome to plug-in demo 1!','Plug-In Demo 1',0,mb_Ok or mb_Moveable);
  WinSendMsg(Window,pim_End,0,0);
  PlugInFunc1 := 0;
end;

Function PlugInFunc2(Window : HWnd;Param1,Param2 : LongInt) : LongInt; cdecl; export;
 var
  Lines,x : LongInt;
  Len : LongInt;
  Struct : TPIGetLineStruct;
 begin
  WinSendMsg(Window,pim_Init,0,0);
  Lines := WinSendMsg(Window,pim_GetNumLines,0,0);
  for x := 0 to Lines-1 do
  begin
   Len := WinSendMsg(Window,pim_GetLineLength,x,0)+1;
   Struct.LineNr := x;
   GetMem(Struct.Buffer,Len);
   Struct.BufferSize := Len;
   WinSendMsg(Window,pim_Getline,LongInt(@Struct),0);
   StrUpper(Struct.Buffer);
   WinSendMsg(Window,pim_SetLine,x,LongInt(Struct.Buffer));
   FreeMem(Struct.Buffer,Len);
  end;
  WinSendMsg(Window,pim_End,0,0);
  PlugInFunc2 := 0;
end;

Function PlugInFunc3(Window : HWnd;Param1,Param2 : LongInt) : LongInt; cdecl; export;
 var
  Lines,x : LongInt;
  Len : LongInt;
  Struct : TPIGetLineStruct;
 begin
  WinSendMsg(Window,pim_Init,0,0);
  Lines := WinSendMsg(Window,pim_GetNumLines,0,0);
  for x := 0 to Lines-1 do
  begin
   Len := WinSendMsg(Window,pim_GetLineLength,x,0)+1;
   Struct.LineNr := x;
   GetMem(Struct.Buffer,Len);
   Struct.BufferSize := Len;
   WinSendMsg(Window,pim_Getline,LongInt(@Struct),0);
   StrLower(Struct.Buffer);
   WinSendMsg(Window,pim_SetLine,x,LongInt(Struct.Buffer));
   FreeMem(Struct.Buffer,Len);
  end;
  WinSendMsg(Window,pim_End,0,0);
  PlugInFunc3 := 0;
end;

exports
 PlugInInstall index 1,
 PlugInFunc1   index 2,
 PlugInFunc2   index 3,
 PluginFunc3   index 4;

begin
end.
